% analytic mesh generation for SMB process
clear all;
%load 'SMB_movie_BT_exp.mm3'
%AA=SMB_movie_BT_exp;
load 'output_SMB8_xylene_Fowler_v3_360_EC.mm3'
load 'output_SMB8_xylene_Fowler_v3_360_EC.mm3'
AA=output_SMB8_xylene_Fowler_v3_360_EC;
AB=output_SMB8_xylene_Fowler_v3_360_EC;


% 4 SMB section decision
[i_time_full,i_mesh]=size(AA);
NumComp = 6;
i_time=(i_time_full-1)/NumComp;  % 6 components
i_time_half = (i_time-1)/2;
tau=1.19;

x0=0;
xf=24;
c0=0.0;
cf=600;
cm=100;

interval_data = 5;
for i=4:interval_data:i_mesh
    j=int8(1+(i-4)/interval_data);
    meshfix(j)=AA(1,i);
end


% t=0
for i=4:interval_data:i_mesh
    j=int8(1+(i-4)/interval_data);
    conc1(1,j)=AA(2+(0),i);
    conc1(2,j)=AA(3+(0),i);
    conc1(3,j)=AA(4+(0),i);
    conc1(4,j)=AA(5+(0),i);
    conc1(5,j)=AA(7+(0),i);
%    conc1(5,j)=AA(6+(0),i);
    conc11(1,j)=AB(2+(0),i);
    conc11(2,j)=AB(3+(0),i);
    conc11(3,j)=AB(4+(0),i);
    conc11(4,j)=AB(5+(0),i);
    conc11(5,j)=AB(7+(0),i);
%    conc11(5,j)=AB(6+(0),i);
    TotalConc1(j)=conc1(1,j)+conc1(2,j);
    
    k1=NumComp*(i_time_half);
    conc2(1,j)=AA(2 + k1,i);
    conc2(2,j)=AA(3 + k1,i);
    conc2(3,j)=AA(4 + k1,i);
    conc2(4,j)=AA(5 + k1,i);
    conc2(5,j)=AA(7 + k1,i);

    conc22(1,j)=AB(2 + k1,i);
    conc22(2,j)=AB(3 + k1,i);
    conc22(3,j)=AB(4 + k1,i);
    conc22(4,j)=AB(5 + k1,i);
    conc22(5,j)=AB(7 + k1,i);
    TotalConc2(j)=conc2(1,j)+conc2(2,j);
    
    k2=NumComp*(i_time-1);
    conc3(1,j)=AA(2+k2,i);
    conc3(2,j)=AA(3+k2,i);
    conc3(3,j)=AA(4+k2,i);
    conc3(4,j)=AA(5+k2,i);
    conc3(5,j)=AA(7+k2,i);

    conc33(1,j)=AB(2+k2,i);
    conc33(2,j)=AB(3+k2,i);
    conc33(3,j)=AB(4+k2,i);
    conc33(4,j)=AB(5+k2,i);
    conc33(5,j)=AB(7+k2,i);
    TotalConc3(j)=conc3(1,j)+conc3(2,j);
end

%purity calculation


% base line
% base line
x1=[1 1];
y1=[c0 cf];
x2=[5 5];
y2=[c0 cf];
x3=[6 6];
y3=[c0 cf];
x4=[12 12];
y4=[c0 cf];
x5=[14 14];
y5=[c0 cf];
x6=[16 16];
y6=[c0 cf];
x7=[21 21];
y7=[c0 cf];

% subplot for fixed. moving, moving/fixed
figure;
subplot(3,1,1);
% plot(column1x,columny,'--', 'LineWidth',1); hold on;
% plot(column2x,columny,'--', 'LineWidth',1); hold on;
plot(meshfix(:),conc1(1,:),'s', 'LineWidth',1, 'Color', 'r','MarkerSize',2); hold on;
plot(meshfix(:),conc1(2,:),'o', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix(:),conc1(3,:),'+', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix(:),conc1(4,:),'^', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
%plot(meshfix(:),conc1(5,:),'-', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;

plot(meshfix,conc11(1,:),'--', 'LineWidth',1, 'Color', 'r','MarkerSize',2); hold on;
plot(meshfix,conc11(2,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc11(3,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc11(4,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
%plot(meshfix,conc11(5,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
%plot(meshfix,TotalConc1(:),':k', 'LineWidth',2, 'MarkerSize',1); hold on;

plot(x1,y1,'--','LineWidth',0.3,'color','k'); hold on;
plot(x2,y2,'--','LineWidth',0.3,'color','k'); hold on;
plot(x3,y3,'--','LineWidth',0.3,'color','k'); hold on;
plot(x4,y4,'--','LineWidth',0.3,'color','k'); hold on;
plot(x5,y5,'--','LineWidth',0.3,'color','k'); hold on;
plot(x6,y6,'--','LineWidth',0.3,'color','k'); hold on;
plot(x7,y7,'--','LineWidth',0.3,'color','k'); hold on;

%text(1,2.75,'(a) level 1 (t=\tau/2)','FontSize',8,'FontWeight','bold')
xlabel('Column number','FontSize',8)
ylabel('Concentration, kg/m^3','FontSize',8)
axis([x0 xf c0 cf])
set(gca,'XTick',x0:1:xf,'FontSize',7)
set(gca,'YTick',c0:cm:cf,'FontSize',7)
% axes('position',[.1  .1  .8  .6]);

subplot(3,1,2);
% plot(column1x,columny,'--', 'LineWidth',1); hold on;
% plot(column2x,columny,'--', 'LineWidth',1); hold on;
plot(meshfix,conc2(1,:),'s', 'LineWidth',1, 'Color', 'r','MarkerSize',2); hold on;
plot(meshfix,conc2(2,:),'o', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc2(3,:),'+', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc2(4,:),'^', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
%plot(meshfix,conc2(5,:),'-', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;

plot(meshfix,conc22(1,:),'--', 'LineWidth',1, 'Color', 'r','MarkerSize',2); hold on;
plot(meshfix,conc22(2,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc22(3,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc22(4,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
%plot(meshfix,conc22(5,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;

%plot(meshfix,TotalConc1(:),':k', 'LineWidth',2, 'MarkerSize',1); hold on;

plot(x1,y1,'--','LineWidth',0.3,'color','k'); hold on;
plot(x2,y2,'--','LineWidth',0.3,'color','k'); hold on;
plot(x3,y3,'--','LineWidth',0.3,'color','k'); hold on;
plot(x4,y4,'--','LineWidth',0.3,'color','k'); hold on;
plot(x5,y5,'--','LineWidth',0.3,'color','k'); hold on;
plot(x6,y6,'--','LineWidth',0.3,'color','k'); hold on;
plot(x7,y7,'--','LineWidth',0.3,'color','k'); hold on;

%text(1,2.75,'(a) level 1 (t=\tau/2)','FontSize',8,'FontWeight','bold')
xlabel('Column number','FontSize',8)
ylabel('Concentration, kg/m^3','FontSize',8)
axis([x0 xf c0 cf])
set(gca,'XTick',x0:1:xf,'FontSize',7)
set(gca,'YTick',c0:cm:cf,'FontSize',7)
% axes('position',[.1  .1  .8  .6]);

subplot(3,1,3);
% plot(column1x,columny,'--', 'LineWidth',1); hold on;
% plot(column2x,columny,'--', 'LineWidth',1); hold on;
plot(meshfix,conc3(1,:),'s', 'LineWidth',1, 'Color', 'r','MarkerSize',2); hold on;
plot(meshfix,conc3(2,:),'o', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc3(3,:),'+', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc3(4,:),'^', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
%plot(meshfix,conc3(5,:),'-', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;

plot(meshfix,conc33(1,:),'--', 'LineWidth',1, 'Color', 'r','MarkerSize',2); hold on;
plot(meshfix,conc33(2,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc33(3,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
plot(meshfix,conc33(4,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;
%plot(meshfix,conc33(5,:),'--', 'LineWidth',1, 'Color', 'k','MarkerSize',2); hold on;

%plot(meshfix,TotalConc1(:),':k', 'LineWidth',2, 'MarkerSize',1); hold on;

plot(x1,y1,'--','LineWidth',0.3,'color','k'); hold on;
plot(x2,y2,'--','LineWidth',0.3,'color','k'); hold on;
plot(x3,y3,'--','LineWidth',0.3,'color','k'); hold on;
plot(x4,y4,'--','LineWidth',0.3,'color','k'); hold on;
plot(x5,y5,'--','LineWidth',0.3,'color','k'); hold on;
plot(x6,y6,'--','LineWidth',0.3,'color','k'); hold on;
plot(x7,y7,'--','LineWidth',0.3,'color','k'); hold on;

%text(1,2.75,'(a) level 1 (t=\tau/2)','FontSize',8,'FontWeight','bold')
xlabel('Column number','FontSize',8)
ylabel('Concentration, kg/m^3','FontSize',8)
axis([x0 xf c0 cf])
set(gca,'XTick',x0:1:xf,'FontSize',7)
set(gca,'YTick',c0:cm:cf,'FontSize',7)
% axes('position',[.1  .1  .8  .6]);

hold off;

% intial condition file creation by matlab.
NVar = 2;       % LDF model
NumComp = 6;    % 
NumColum = 24;  % SamsungTotal SMB process
NGrid = 16;
T_Row = NVar*NumComp*NumColum;
T_column = NumColum*NGrid;

% load 'output_SMB8_xylene_Fowler_v2_300s3_all.mm3'  % to be revised
% DD = output_SMB8_xylene_Fowler_v2_300s3_all;
DD = zeros(T_Row, T_column+3);
% [N_row, N_column]=size(DD);
for i_row= 1 : NVar*NumComp 
    for i_column = 1: T_column
        k= NVar*NumComp - i_row;
        DF(i_row, i_column) = DD (T_Row - k , i_column+3);
    end
end

SMB_IC_value = zeros(T_Row, NGrid);
for i_bed = 1: NumColum
    for  i_row= 1:NVar*NumComp
        for i_mesh = 1:NGrid       
            j_mesh = (i_bed-1)*NGrid + i_mesh;
            SMB_IC_value(i_row, i_mesh) = DF(i_row, j_mesh);
        end
    end
end
save('SamSungTotal_SMB_IC.dat', 'SMB_IC_value', '-ASCII')
% end of Program

